/* happy pam module that makes syslog() calls to log who is coming onto the
	machine from where, and using what service (telnet, ssh, etc..)

let's just say this is GPL'ed and have done

	- capveg '01
*/

#define PAM_SM_AUTH
#include <security/pam_appl.h>
#include <security/pam_modules.h>


#include <stdio.h>
#include <syslog.h>
#include <errno.h>
#include <string.h>


#define SYSLOGSTR "pam_logservice"
#define BUFSIZE 1024

int pam_sm_authenticate(pam_handle_t *pamh, int flags, int argc, const char **argv){
#ifdef DEBUG
	openlog(SYSLOGSTR,LOG_PID,LOG_AUTH);
	syslog(LOG_DEBUG, "called pam_sm_authenticate()");
#endif

	return PAM_SUCCESS;
}
	

int pam_sm_open_session(pam_handle_t *pamh, int flags,
          int argc, const char **argv){

#ifdef DEBUG
	openlog(SYSLOGSTR,LOG_PID,LOG_AUTH);
	syslog(LOG_DEBUG, "called pam_sm_open_session()");
#endif


        return (PAM_SUCCESS);
}

int pam_sm_close_session(pam_handle_t *pamh, int flags,
          int argc, const char **argv){
#ifdef DEBUG
	openlog(SYSLOGSTR,LOG_PID,LOG_AUTH);
	syslog(LOG_DEBUG, "called pam_sm_close_session()");
#endif
        return (PAM_SUCCESS);
}

int pam_sm_setcred(
        pam_handle_t    *pamh,
        int     flags,
        int     argc,
        const char      **argv){

	int err;
	char *username, *service, *remotehost;

	openlog(SYSLOGSTR,LOG_PID,LOG_AUTH);
#ifdef DEBUG
   syslog(LOG_DEBUG, "called pam_sm_setcred()");
#endif

	err=pam_get_item(pamh,PAM_USER , (void **) &username);
	if(err != PAM_SUCCESS) {
		syslog(LOG_ERR," pam_get_item SERVICE: %s ", pam_strerror(pamh,err));
		closelog();
		return err;
	}
	if(strlen(username) <= 0 ){ /* get user name and set it */
		syslog(LOG_DEBUG, " username not set... prompting");
		err = pam_get_user(pamh, &username, NULL);
		if (err != PAM_SUCCESS) {
			syslog(LOG_ERR," pam_get_USER %s ", pam_strerror(pamh,err));
			closelog();
			return (err);
		}

		err = pam_set_item(pamh,PAM_USER,&username);
		if (err != PAM_SUCCESS) {
			syslog(LOG_ERR," pam_set_USER %s ", pam_strerror(pamh,err));
			closelog();
			return (err);
		}
	}


	err=pam_get_item(pamh,PAM_SERVICE , (void **) &service);
	if(err != PAM_SUCCESS) {
		syslog(LOG_ERR," pam_get_item SERVICE: %s ", pam_strerror(pamh,err));
		closelog();
		return err;
	}
	err=pam_get_item(pamh,PAM_RHOST , (void **) &remotehost);
	if(err != PAM_SUCCESS) {
		syslog(LOG_ERR," pam_get_item RHOST: %s ", pam_strerror(pamh,err));
		closelog();
		return err;
	}
	
	syslog(LOG_INFO, "USER '%s' SERVICE '%s' HOST '%s'",username,
		service, remotehost);

#ifdef DEBUG
	syslog(LOG_DEBUG, "exiting sucessfully");
#endif
	closelog();


        return (PAM_SUCCESS);
}

int
pam_sm_acct_mgmt(
        pam_handle_t    *pamh,
        int     flags,
        int     argc,
        const char      **argv){

#ifdef DEBUG
	openlog(SYSLOGSTR,LOG_PID,LOG_AUTH);
   syslog(LOG_DEBUG, "called pam_sm_acct_mgmt()");
#endif
        return (PAM_SUCCESS);
}

int
pam_sm_chauthtok(
        pam_handle_t    *pamh,
        int             flags,
        int             argc,
        const char      **argv){


#ifdef DEBUG
	openlog(SYSLOGSTR,LOG_PID,LOG_AUTH);
   syslog(LOG_DEBUG, "called pam_sm_chauthtok()");
#endif
        return (PAM_SUCCESS);
}

